#ifndef _STRING_H
#define _STRING_H

#include <bits/attrs.h>
#include <sys/types.h>

#ifdef __cplusplus
extern "C"
{
#endif

    void* memcpy(void* dest, const void* src, size_t n);
    void* memset(void* buf, int c, size_t n);
    int memcmp(const void* a, const void* b, size_t n);
    void* memmove(void* dest, const void* src, size_t n);
    size_t strlen(const char* str);

    int strcmp(const char* a, const char* b);
    __deprecated char* strcpy(char* dest, const char* src);
    __deprecated char* strcat(char* dest, const char* src);
    char* strchr(const char* str, int c);

    char* strdup(const char* str);

    char* strerror(int errnum);

#ifdef __cplusplus
}
#endif

#endif
